''*******************************
''* SHOW.spin            5/2016 *
''* Author: Werner L. Schneider *
''*******************************
''
''
VAR

    long cog                     ' cog flag/id

    'DO NOT REARRANGE LONGS
    long show_ptr                ' 2 contiguous longs
    long vga_ptr


PUB start(ShowPtr, VgaPtr) : okay

    stop
    longmove(@show_ptr, @ShowPtr, 2)
    okay := cog := cognew(@entry, @show_ptr) + 1


PUB stop

  '' Stop driver - frees a cog

    if cog
      cogstop(cog~ - 1)
    longfill(@show_ptr, 0, 2)


DAT

'***********************************
'* Assembly language "show" driver *
'***********************************

                        org     
'
' Entry
'
entry
                        mov     t1, par                
                        rdlong  _showbuff, t1          ' get show_ptr

                        add     t1, #4                 
                        rdlong  _vgabuff, t1           ' get vga_ptr




bigloop                 mov     _showptr, _showbuff                 
                        mov     _vgaptr, _vgabuff                 
                        add     _vgaptr, #220
                        mov     _row, #20

nextrow                 mov     _col, #10

nextcol                 rdbyte  t1, _showptr
                        add     _showptr, #1           ' move read pointer one byte

                        mov     _showdata, t1
                        shl     _showdata, #8
                        add     _showdata, t1
                        wrword  _showdata, _vgaptr 
                        add     _vgaptr, #2            ' move write pointer one word
                        or      _showdata, #%10000000
                        wrword  _showdata, _vgaptr 
                        add     _vgaptr, #2            ' move write pointer one word
                        djnz    _col, #nextcol         

                        add     _vgaptr, #120
                        djnz    _row, #nextrow         

                        jmp     #bigloop


                        'Data

'
' Uninitialized data
'
t1                      res     1

_showbuff               res     1
_showptr                res     1
_showdata               res     1

_vgabuff                res     1
_vgaptr                 res     1

_row                    res     1
_col                    res     1



                        fit 496
                        